Index: pjproject/trunk/pjsip-apps/src/python/_pjsua.c
===================================================================
--- pjproject/trunk/pjsip-apps/src/python/_pjsua.c	(revision 2158)
+++ pjproject/trunk/pjsip-apps/src/python/_pjsua.c	(revision 2163)
@@ -2415,865 +2241,29 @@
 
 
-
-/*
- * PyObj_pjsua_codec_info
- * Codec Info
- * !modified @ 071206
- */
-typedef struct
-{
-    PyObject_HEAD
-    /* Type-specific fields go here. */ 
-    
-    PyObject * codec_id;
-    pj_uint8_t priority;    
-    char buf_[32];
-} PyObj_pjsua_codec_info;
-
-
-/*
- * codec_info_dealloc
- * deletes a codec_info from memory
- * !modified @ 071206
- */
-static void codec_info_dealloc(PyObj_pjsua_codec_info* self)
-{
-    Py_XDECREF(self->codec_id);    
-    
-    self->ob_type->tp_free((PyObject*)self);
-}
-
-
-/*
- * codec_info_new
- * constructor for codec_info object
- * !modified @ 071206
- */
-static PyObject * codec_info_new(PyTypeObject *type, PyObject *args,
-                                    PyObject *kwds)
-{
-    PyObj_pjsua_codec_info *self;
-
-    PJ_UNUSED_ARG(args);
-    PJ_UNUSED_ARG(kwds);
-
-    self = (PyObj_pjsua_codec_info *)type->tp_alloc(type, 0);
-    if (self != NULL)
-    {
-        self->codec_id = PyString_FromString("");
-        if (self->codec_id == NULL)
-    	{
-            Py_DECREF(self);
-            return NULL;
-        }        
-	
-
-    }
-    return (PyObject *)self;
-}
-
-/*
- * codec_info_members
- * !modified @ 071206
- */
-static PyMemberDef codec_info_members[] =
+/*
+ * py_pjsua_conf_get_max_ports
+ */
+static PyObject *py_pjsua_conf_get_max_ports(PyObject *pSelf, PyObject *pArgs)
 {    
-    {
-        "codec_id", T_OBJECT_EX,
-        offsetof(PyObj_pjsua_codec_info, codec_id), 0,
-        "Codec unique identification."        
-    },
-    
-    {
-        "priority", T_INT, 
-        offsetof(PyObj_pjsua_codec_info, priority), 0,
-        "Codec priority (integer 0-255)."
-    },
-    
-    
-    
-    {NULL}  /* Sentinel */
-};
-
-
-
-
-/*
- * PyTyp_pjsua_codec_info
- */
-static PyTypeObject PyTyp_pjsua_codec_info =
-{
-    PyObject_HEAD_INIT(NULL)
-    0,                              /*ob_size*/
-    "_pjsua.Codec_Info",      /*tp_name*/
-    sizeof(PyObj_pjsua_codec_info),  /*tp_basicsize*/
-    0,                              /*tp_itemsize*/
-    (destructor)codec_info_dealloc,/*tp_dealloc*/
-    0,                              /*tp_print*/
-    0,                              /*tp_getattr*/
-    0,                              /*tp_setattr*/
-    0,                              /*tp_compare*/
-    0,                              /*tp_repr*/
-    0,                              /*tp_as_number*/
-    0,                              /*tp_as_sequence*/
-    0,                              /*tp_as_mapping*/
-    0,                              /*tp_hash */
-    0,                              /*tp_call*/
-    0,                              /*tp_str*/
-    0,                              /*tp_getattro*/
-    0,                              /*tp_setattro*/
-    0,                              /*tp_as_buffer*/
-    Py_TPFLAGS_DEFAULT,             /*tp_flags*/
-    "Codec Info objects",       /* tp_doc */
-    0,                              /* tp_traverse */
-    0,                              /* tp_clear */
-    0,                              /* tp_richcompare */
-    0,                              /* tp_weaklistoffset */
-    0,                              /* tp_iter */
-    0,                              /* tp_iternext */
-    0,                              /* tp_methods */
-    codec_info_members,         /* tp_members */
-    0,                              /* tp_getset */
-    0,                              /* tp_base */
-    0,                              /* tp_dict */
-    0,                              /* tp_descr_get */
-    0,                              /* tp_descr_set */
-    0,                              /* tp_dictoffset */
-    0,                              /* tp_init */
-    0,                              /* tp_alloc */
-    codec_info_new,             /* tp_new */
-
-};
-
-/*
- * PyObj_pjsua_conf_port_info
- * Conf Port Info
- */
-typedef struct
-{
-    PyObject_HEAD
-    /* Type-specific fields go here. */ 
-    
-    int  slot_id;
-    PyObject *  name;
-    unsigned  clock_rate;
-    unsigned  channel_count;
-    unsigned  samples_per_frame;
-    unsigned  bits_per_sample;
-    PyListObject * listeners;
-
-} PyObj_pjsua_conf_port_info;
-
-
-/*
- * conf_port_info_dealloc
- * deletes a conf_port_info from memory
- */
-static void conf_port_info_dealloc(PyObj_pjsua_conf_port_info* self)
-{
-    Py_XDECREF(self->name);    
-    Py_XDECREF(self->listeners);
-    self->ob_type->tp_free((PyObject*)self);
-}
-
-
-/*
- * conf_port_info_new
- * constructor for conf_port_info object
- */
-static PyObject * conf_port_info_new(PyTypeObject *type, PyObject *args,
-                                    PyObject *kwds)
-{
-    PyObj_pjsua_conf_port_info *self;
-
-    PJ_UNUSED_ARG(args);
-    PJ_UNUSED_ARG(kwds);
-
-    self = (PyObj_pjsua_conf_port_info *)type->tp_alloc(type, 0);
-    if (self != NULL)
-    {
-        self->name = PyString_FromString("");
-        if (self->name == NULL)
-    	{
-            Py_DECREF(self);
-            return NULL;
-        }        
-	
-	self->listeners = (PyListObject *)PyList_New(0);
-        if (self->listeners == NULL)
-    	{
-            Py_DECREF(self);
-            return NULL;
-        }
-    }
-    return (PyObject *)self;
-}
-
-/*
- * conf_port_info_members
- */
-static PyMemberDef conf_port_info_members[] =
-{   
-    {
-        "slot_id", T_INT, 
-        offsetof(PyObj_pjsua_conf_port_info, slot_id), 0,
-        "Conference port number."
-    },
-    {
-        "name", T_OBJECT_EX,
-        offsetof(PyObj_pjsua_conf_port_info, name), 0,
-        "Port name"        
-    },
-    {
-        "clock_rate", T_INT, 
-        offsetof(PyObj_pjsua_conf_port_info, clock_rate), 0,
-        "Clock rate"
-    },
-    {
-        "channel_count", T_INT, 
-        offsetof(PyObj_pjsua_conf_port_info, channel_count), 0,
-        "Number of channels."
-    },
-    {
-        "samples_per_frame", T_INT, 
-        offsetof(PyObj_pjsua_conf_port_info, samples_per_frame), 0,
-        "Samples per frame "
-    },
-    {
-        "bits_per_sample", T_INT, 
-        offsetof(PyObj_pjsua_conf_port_info, bits_per_sample), 0,
-        "Bits per sample"
-    },
-    {
-        "listeners", T_OBJECT_EX,
-        offsetof(PyObj_pjsua_conf_port_info, listeners), 0,
-        "Array of listeners (in other words, ports where this port "
-	"is transmitting to"
-    },
-    
-    {NULL}  /* Sentinel */
-};
-
-
-
-
-/*
- * PyTyp_pjsua_conf_port_info
- */
-static PyTypeObject PyTyp_pjsua_conf_port_info =
-{
-    PyObject_HEAD_INIT(NULL)
-    0,                              /*ob_size*/
-    "_pjsua.Conf_Port_Info",      /*tp_name*/
-    sizeof(PyObj_pjsua_conf_port_info),  /*tp_basicsize*/
-    0,                              /*tp_itemsize*/
-    (destructor)conf_port_info_dealloc,/*tp_dealloc*/
-    0,                              /*tp_print*/
-    0,                              /*tp_getattr*/
-    0,                              /*tp_setattr*/
-    0,                              /*tp_compare*/
-    0,                              /*tp_repr*/
-    0,                              /*tp_as_number*/
-    0,                              /*tp_as_sequence*/
-    0,                              /*tp_as_mapping*/
-    0,                              /*tp_hash */
-    0,                              /*tp_call*/
-    0,                              /*tp_str*/
-    0,                              /*tp_getattro*/
-    0,                              /*tp_setattro*/
-    0,                              /*tp_as_buffer*/
-    Py_TPFLAGS_DEFAULT,             /*tp_flags*/
-    "Conf Port Info objects",       /* tp_doc */
-    0,                              /* tp_traverse */
-    0,                              /* tp_clear */
-    0,                              /* tp_richcompare */
-    0,                              /* tp_weaklistoffset */
-    0,                              /* tp_iter */
-    0,                              /* tp_iternext */
-    0,                              /* tp_methods */
-    conf_port_info_members,         /* tp_members */
-    0,                              /* tp_getset */
-    0,                              /* tp_base */
-    0,                              /* tp_dict */
-    0,                              /* tp_descr_get */
-    0,                              /* tp_descr_set */
-    0,                              /* tp_dictoffset */
-    0,                              /* tp_init */
-    0,                              /* tp_alloc */
-    conf_port_info_new,             /* tp_new */
-
-};
-
-/*
- * PyObj_pjmedia_port
- */
-typedef struct
-{
-    PyObject_HEAD
-    /* Type-specific fields go here. */
-    pjmedia_port * port;
-} PyObj_pjmedia_port;
-
-
-/*
- * PyTyp_pjmedia_port
- */
-static PyTypeObject PyTyp_pjmedia_port =
-{
-    PyObject_HEAD_INIT(NULL)
-    0,                         /*ob_size*/
-    "_pjsua.PJMedia_Port",        /*tp_name*/
-    sizeof(PyObj_pjmedia_port),    /*tp_basicsize*/
-    0,                         /*tp_itemsize*/
-    0,                         /*tp_dealloc*/
-    0,                         /*tp_print*/
-    0,                         /*tp_getattr*/
-    0,                         /*tp_setattr*/
-    0,                         /*tp_compare*/
-    0,                         /*tp_repr*/
-    0,                         /*tp_as_number*/
-    0,                         /*tp_as_sequence*/
-    0,                         /*tp_as_mapping*/
-    0,                         /*tp_hash */
-    0,                         /*tp_call*/
-    0,                         /*tp_str*/
-    0,                         /*tp_getattro*/
-    0,                         /*tp_setattro*/
-    0,                         /*tp_as_buffer*/
-    Py_TPFLAGS_DEFAULT,        /*tp_flags*/
-    "pjmedia_port objects",       /* tp_doc */
-
-};
-
-/*
- * PyObj_pjmedia_snd_dev_info
- * PJMedia Snd Dev Info
- */
-typedef struct
-{
-    PyObject_HEAD
-    /* Type-specific fields go here. */ 
-    
-    
-    unsigned  input_count;
-    unsigned  output_count;
-    unsigned  default_samples_per_sec;    
-    PyObject * name;
-
-} PyObj_pjmedia_snd_dev_info;
-
-
-/*
- * pjmedia_snd_dev_info_dealloc
- * deletes a pjmedia_snd_dev_info from memory
- */
-static void pjmedia_snd_dev_info_dealloc(PyObj_pjmedia_snd_dev_info* self)
-{
-    Py_XDECREF(self->name);        
-    self->ob_type->tp_free((PyObject*)self);
-}
-
-
-/*
- * pjmedia_snd_dev_info_new
- * constructor for pjmedia_snd_dev_info object
- */
-static PyObject * pjmedia_snd_dev_info_new(PyTypeObject *type, PyObject *args,
-                                    PyObject *kwds)
-{
-    PyObj_pjmedia_snd_dev_info *self;
-
-    PJ_UNUSED_ARG(args);
-    PJ_UNUSED_ARG(kwds);
-
-    self = (PyObj_pjmedia_snd_dev_info *)type->tp_alloc(type, 0);
-    if (self != NULL)
-    {
-        self->name = PyString_FromString("");
-        if (self->name == NULL)
-    	{
-            Py_DECREF(self);
-            return NULL;
-        }        
-	
-    }
-    return (PyObject *)self;
-}
-
-/*
- * pjmedia_snd_dev_info_members
- */
-static PyMemberDef pjmedia_snd_dev_info_members[] =
-{   
-    
-    {
-        "name", T_OBJECT_EX,
-        offsetof(PyObj_pjmedia_snd_dev_info, name), 0,
-        "Device name"        
-    },
-    {
-        "input_count", T_INT, 
-        offsetof(PyObj_pjmedia_snd_dev_info, input_count), 0,
-        "Max number of input channels"
-    },
-    {
-        "output_count", T_INT, 
-        offsetof(PyObj_pjmedia_snd_dev_info, output_count), 0,
-        "Max number of output channels"
-    },
-    {
-        "default_samples_per_sec", T_INT, 
-        offsetof(PyObj_pjmedia_snd_dev_info, default_samples_per_sec), 0,
-        "Default sampling rate."
-    },
-    
-    
-    {NULL}  /* Sentinel */
-};
-
-
-
-
-/*
- * PyTyp_pjmedia_snd_dev_info
- */
-static PyTypeObject PyTyp_pjmedia_snd_dev_info =
-{
-    PyObject_HEAD_INIT(NULL)
-    0,                              /*ob_size*/
-    "_pjsua.PJMedia_Snd_Dev_Info",      /*tp_name*/
-    sizeof(PyObj_pjmedia_snd_dev_info),  /*tp_basicsize*/
-    0,                              /*tp_itemsize*/
-    (destructor)pjmedia_snd_dev_info_dealloc,/*tp_dealloc*/
-    0,                              /*tp_print*/
-    0,                              /*tp_getattr*/
-    0,                              /*tp_setattr*/
-    0,                              /*tp_compare*/
-    0,                              /*tp_repr*/
-    0,                              /*tp_as_number*/
-    0,                              /*tp_as_sequence*/
-    0,                              /*tp_as_mapping*/
-    0,                              /*tp_hash */
-    0,                              /*tp_call*/
-    0,                              /*tp_str*/
-    0,                              /*tp_getattro*/
-    0,                              /*tp_setattro*/
-    0,                              /*tp_as_buffer*/
-    Py_TPFLAGS_DEFAULT,             /*tp_flags*/
-    "PJMedia Snd Dev Info objects",       /* tp_doc */
-    0,                              /* tp_traverse */
-    0,                              /* tp_clear */
-    0,                              /* tp_richcompare */
-    0,                              /* tp_weaklistoffset */
-    0,                              /* tp_iter */
-    0,                              /* tp_iternext */
-    0,                              /* tp_methods */
-    pjmedia_snd_dev_info_members,         /* tp_members */
-    0,                              /* tp_getset */
-    0,                              /* tp_base */
-    0,                              /* tp_dict */
-    0,                              /* tp_descr_get */
-    0,                              /* tp_descr_set */
-    0,                              /* tp_dictoffset */
-    0,                              /* tp_init */
-    0,                              /* tp_alloc */
-    pjmedia_snd_dev_info_new,             /* tp_new */
-
-};
-
-/*
- * PyObj_pjmedia_codec_param_info
- * PJMedia Codec Param Info
- */
-typedef struct
-{
-    PyObject_HEAD
-    /* Type-specific fields go here. */ 
-    
-    unsigned  clock_rate;
-    unsigned  channel_cnt;
-    pj_uint32_t avg_bps;
-    pj_uint16_t frm_ptime;
-    pj_uint8_t  pcm_bits_per_sample;
-    pj_uint8_t  pt;	
-
-} PyObj_pjmedia_codec_param_info;
-
-
-
-/*
- * pjmedia_codec_param_info_members
- */
-static PyMemberDef pjmedia_codec_param_info_members[] =
-{   
-    
-    {
-        "clock_rate", T_INT, 
-        offsetof(PyObj_pjmedia_codec_param_info, clock_rate), 0,
-        "Sampling rate in Hz"
-    },
-    {
-        "channel_cnt", T_INT, 
-        offsetof(PyObj_pjmedia_codec_param_info, channel_cnt), 0,
-        "Channel count"
-    },
-    {
-        "avg_bps", T_INT, 
-        offsetof(PyObj_pjmedia_codec_param_info, avg_bps), 0,
-        "Average bandwidth in bits/sec"
-    },
-    {
-        "frm_ptime", T_INT, 
-        offsetof(PyObj_pjmedia_codec_param_info, frm_ptime), 0,
-        "Base frame ptime in msec."
-    },
-    {
-        "pcm_bits_per_sample", T_INT, 
-        offsetof(PyObj_pjmedia_codec_param_info, pcm_bits_per_sample), 0,
-        "Bits/sample in the PCM side"
-    },
-    {
-        "pt", T_INT, 
-        offsetof(PyObj_pjmedia_codec_param_info, pt), 0,
-        "Payload type"
-    },
-    
-    {NULL}  /* Sentinel */
-};
-
-
-
-
-/*
- * PyTyp_pjmedia_codec_param_info
- */
-static PyTypeObject PyTyp_pjmedia_codec_param_info =
-{
-    PyObject_HEAD_INIT(NULL)
-    0,                              /*ob_size*/
-    "_pjsua.PJMedia_Codec_Param_Info",      /*tp_name*/
-    sizeof(PyObj_pjmedia_codec_param_info),  /*tp_basicsize*/
-    0,                              /*tp_itemsize*/
-    0,/*tp_dealloc*/
-    0,                              /*tp_print*/
-    0,                              /*tp_getattr*/
-    0,                              /*tp_setattr*/
-    0,                              /*tp_compare*/
-    0,                              /*tp_repr*/
-    0,                              /*tp_as_number*/
-    0,                              /*tp_as_sequence*/
-    0,                              /*tp_as_mapping*/
-    0,                              /*tp_hash */
-    0,                              /*tp_call*/
-    0,                              /*tp_str*/
-    0,                              /*tp_getattro*/
-    0,                              /*tp_setattro*/
-    0,                              /*tp_as_buffer*/
-    Py_TPFLAGS_DEFAULT,             /*tp_flags*/
-    "PJMedia Codec Param Info objects",       /* tp_doc */
-    0,                              /* tp_traverse */
-    0,                              /* tp_clear */
-    0,                              /* tp_richcompare */
-    0,                              /* tp_weaklistoffset */
-    0,                              /* tp_iter */
-    0,                              /* tp_iternext */
-    0,                              /* tp_methods */
-    pjmedia_codec_param_info_members,         /* tp_members */
-    
-
-};
-
-/*
- * PyObj_pjmedia_codec_param_setting
- * PJMedia Codec Param Setting
- */
-typedef struct
-{
-    PyObject_HEAD
-    /* Type-specific fields go here. */ 
-    pj_uint8_t  frm_per_pkt; 
-    unsigned    vad;
-    unsigned    cng;
-    unsigned    penh;
-    unsigned    plc;
-    unsigned    reserved;
-    pj_uint8_t  enc_fmtp_mode;
-    pj_uint8_t  dec_fmtp_mode; 
-
-} PyObj_pjmedia_codec_param_setting;
-
-
-
-/*
- * pjmedia_codec_param_setting_members
- */
-static PyMemberDef pjmedia_codec_param_setting_members[] =
-{   
-    
-    {
-        "frm_per_pkt", T_INT, 
-        offsetof(PyObj_pjmedia_codec_param_setting, frm_per_pkt), 0,
-        "Number of frames per packet"
-    },
-    {
-        "vad", T_INT, 
-        offsetof(PyObj_pjmedia_codec_param_setting, vad), 0,
-        "Voice Activity Detector"
-    },
-    {
-        "penh", T_INT, 
-        offsetof(PyObj_pjmedia_codec_param_setting, penh), 0,
-        "Perceptual Enhancement"
-    },
-    {
-        "plc", T_INT, 
-        offsetof(PyObj_pjmedia_codec_param_setting, plc), 0,
-        "Packet loss concealment"
-    },
-    {
-        "reserved", T_INT, 
-        offsetof(PyObj_pjmedia_codec_param_setting, reserved), 0,
-        "Reserved, must be zero"
-    },
-    {
-        "cng", T_INT, 
-        offsetof(PyObj_pjmedia_codec_param_setting, cng), 0,
-        "Comfort Noise Generator"
-    },
-    {
-        "enc_fmtp_mode", T_INT, 
-        offsetof(PyObj_pjmedia_codec_param_setting, enc_fmtp_mode), 0,
-        "Mode param in fmtp (def:0)"
-    },
-    {
-        "dec_fmtp_mode", T_INT, 
-        offsetof(PyObj_pjmedia_codec_param_setting, dec_fmtp_mode), 0,
-        "Mode param in fmtp (def:0)"
-    },
-    
-    {NULL}  /* Sentinel */
-};
-
-
-
-
-/*
- * PyTyp_pjmedia_codec_param_setting
- */
-static PyTypeObject PyTyp_pjmedia_codec_param_setting =
-{
-    PyObject_HEAD_INIT(NULL)
-    0,                              /*ob_size*/
-    "_pjsua.PJMedia_Codec_Param_Setting",      /*tp_name*/
-    sizeof(PyObj_pjmedia_codec_param_setting),  /*tp_basicsize*/
-    0,                              /*tp_itemsize*/
-    0,/*tp_dealloc*/
-    0,                              /*tp_print*/
-    0,                              /*tp_getattr*/
-    0,                              /*tp_setattr*/
-    0,                              /*tp_compare*/
-    0,                              /*tp_repr*/
-    0,                              /*tp_as_number*/
-    0,                              /*tp_as_sequence*/
-    0,                              /*tp_as_mapping*/
-    0,                              /*tp_hash */
-    0,                              /*tp_call*/
-    0,                              /*tp_str*/
-    0,                              /*tp_getattro*/
-    0,                              /*tp_setattro*/
-    0,                              /*tp_as_buffer*/
-    Py_TPFLAGS_DEFAULT,             /*tp_flags*/
-    "PJMedia Codec Param Setting objects",       /* tp_doc */
-    0,                              /* tp_traverse */
-    0,                              /* tp_clear */
-    0,                              /* tp_richcompare */
-    0,                              /* tp_weaklistoffset */
-    0,                              /* tp_iter */
-    0,                              /* tp_iternext */
-    0,                              /* tp_methods */
-    pjmedia_codec_param_setting_members,         /* tp_members */
-    
-
-};
-
-/*
- * PyObj_pjmedia_codec_param
- * PJMedia Codec Param
- */
-typedef struct
-{
-    PyObject_HEAD
-    /* Type-specific fields go here. */ 
-    
-    PyObj_pjmedia_codec_param_info * info;
-    PyObj_pjmedia_codec_param_setting * setting;
-
-} PyObj_pjmedia_codec_param;
-
-
-/*
- * pjmedia_codec_param_dealloc
- * deletes a pjmedia_codec_param from memory
- */
-static void pjmedia_codec_param_dealloc(PyObj_pjmedia_codec_param* self)
-{
-    Py_XDECREF(self->info);        
-    Py_XDECREF(self->setting);        
-    self->ob_type->tp_free((PyObject*)self);
-}
-
-
-/*
- * pjmedia_codec_param_new
- * constructor for pjmedia_codec_param object
- */
-static PyObject * pjmedia_codec_param_new(PyTypeObject *type, PyObject *args,
-                                    PyObject *kwds)
-{
-    PyObj_pjmedia_codec_param *self;
-
-    PJ_UNUSED_ARG(args);
-    PJ_UNUSED_ARG(kwds);
-
-    self = (PyObj_pjmedia_codec_param *)type->tp_alloc(type, 0);
-    if (self != NULL)
-    {
-        self->info = (PyObj_pjmedia_codec_param_info *)
-	    PyType_GenericNew(&PyTyp_pjmedia_codec_param_info, NULL, NULL);
-        if (self->info == NULL)
-    	{
-            Py_DECREF(self);
-            return NULL;
-        }        
-	self->setting = (PyObj_pjmedia_codec_param_setting *)
-	    PyType_GenericNew(&PyTyp_pjmedia_codec_param_setting, NULL, NULL);
-        if (self->setting == NULL)
-    	{
-            Py_DECREF(self);
-            return NULL;
-        }        
-    }
-    return (PyObject *)self;
-}
-
-/*
- * pjmedia_codec_param_members
- */
-static PyMemberDef pjmedia_codec_param_members[] =
-{   
-    
-    {
-        "info", T_OBJECT_EX,
-        offsetof(PyObj_pjmedia_codec_param, info), 0,
-        "The 'info' part of codec param describes the capability of the codec,"
-        " and the value should NOT be changed by application."        
-    },
-    {
-        "setting", T_OBJECT_EX,
-        offsetof(PyObj_pjmedia_codec_param, setting), 0, 
-        "The 'setting' part of codec param describes various settings to be "
-        "applied to the codec. When the codec param is retrieved from the "
-        "codec or codec factory, the values of these will be filled by "
-        "the capability of the codec. Any features that are supported by "
-        "the codec (e.g. vad or plc) will be turned on, so that application "
-        "can query which capabilities are supported by the codec. "
-        "Application may change the settings here before instantiating "
-        "the codec/stream."        
-    },
-    
-    {NULL}  /* Sentinel */
-};
-
-
-
-
-/*
- * PyTyp_pjmedia_codec_param
- */
-static PyTypeObject PyTyp_pjmedia_codec_param =
-{
-    PyObject_HEAD_INIT(NULL)
-    0,                              /*ob_size*/
-    "_pjsua.PJMedia_Codec_Param",      /*tp_name*/
-    sizeof(PyObj_pjmedia_codec_param),  /*tp_basicsize*/
-    0,                              /*tp_itemsize*/
-    (destructor)pjmedia_codec_param_dealloc,/*tp_dealloc*/
-    0,                              /*tp_print*/
-    0,                              /*tp_getattr*/
-    0,                              /*tp_setattr*/
-    0,                              /*tp_compare*/
-    0,                              /*tp_repr*/
-    0,                              /*tp_as_number*/
-    0,                              /*tp_as_sequence*/
-    0,                              /*tp_as_mapping*/
-    0,                              /*tp_hash */
-    0,                              /*tp_call*/
-    0,                              /*tp_str*/
-    0,                              /*tp_getattro*/
-    0,                              /*tp_setattro*/
-    0,                              /*tp_as_buffer*/
-    Py_TPFLAGS_DEFAULT,             /*tp_flags*/
-    "PJMedia Codec Param objects",       /* tp_doc */
-    0,                              /* tp_traverse */
-    0,                              /* tp_clear */
-    0,                              /* tp_richcompare */
-    0,                              /* tp_weaklistoffset */
-    0,                              /* tp_iter */
-    0,                              /* tp_iternext */
-    0,                              /* tp_methods */
-    pjmedia_codec_param_members,         /* tp_members */
-    0,                              /* tp_getset */
-    0,                              /* tp_base */
-    0,                              /* tp_dict */
-    0,                              /* tp_descr_get */
-    0,                              /* tp_descr_set */
-    0,                              /* tp_dictoffset */
-    0,                              /* tp_init */
-    0,                              /* tp_alloc */
-    pjmedia_codec_param_new,             /* tp_new */
-
-};
-
-/*
- * py_pjsua_conf_get_max_ports
- */
-static PyObject *py_pjsua_conf_get_max_ports
-(PyObject *pSelf, PyObject *pArgs)
+    PJ_UNUSED_ARG(pSelf);
+    PJ_UNUSED_ARG(pArgs);
+
+    return Py_BuildValue("i", pjsua_conf_get_max_ports());
+}
+
+/*
+ * py_pjsua_conf_get_active_ports
+ */
+static PyObject *py_pjsua_conf_get_active_ports(PyObject *pSelf, 
+						PyObject *pArgs)
 {    
-    int ret;
-    
-    PJ_UNUSED_ARG(pSelf);
-
-    if (!PyArg_ParseTuple(pArgs, ""))
-    {
-        return NULL;
-    }
-    ret = pjsua_conf_get_max_ports();
-	
-    return Py_BuildValue("i", ret);
-}
-
-/*
- * py_pjsua_conf_get_active_ports
- */
-static PyObject *py_pjsua_conf_get_active_ports
-(PyObject *pSelf, PyObject *pArgs)
-{    
-    int ret;
-
-    PJ_UNUSED_ARG(pSelf);
-
-    if (!PyArg_ParseTuple(pArgs, ""))
-    {
-        return NULL;
-    }
-    ret = pjsua_conf_get_active_ports();
-	
-    return Py_BuildValue("i", ret);
+    PJ_UNUSED_ARG(pSelf);
+    PJ_UNUSED_ARG(pArgs);
+
+    return Py_BuildValue("i", pjsua_conf_get_active_ports());
 }
 
 /*
  * py_pjsua_enum_conf_ports
- * !modified @ 241206
  */
 static PyObject *py_pjsua_enum_conf_ports(PyObject *pSelf, PyObject *pArgs)
@@ -3281,29 +2271,21 @@
     pj_status_t status;
     PyObject *list;
-    
     pjsua_conf_port_id id[PJSUA_MAX_CONF_PORTS];
     unsigned c, i;
 
     PJ_UNUSED_ARG(pSelf);
-
-    if (!PyArg_ParseTuple(pArgs, ""))
-    {
-        return NULL;
-    }	
-    
+    PJ_UNUSED_ARG(pArgs);
+
     c = PJ_ARRAY_SIZE(id);
     status = pjsua_enum_conf_ports(id, &c);
+    if (status != PJ_SUCCESS)
+	c = 0;
     
     list = PyList_New(c);
-    for (i = 0; i < c; i++) 
-    {
-        int ret = PyList_SetItem(list, i, Py_BuildValue("i", id[i]));
-        if (ret == -1) 
-	{
-            return NULL;
-	}
-    }
-    
-    return Py_BuildValue("O",list);
+    for (i = 0; i < c; i++) {
+        PyList_SetItem(list, i, Py_BuildValue("i", id[i]));
+    }
+    
+    return (PyObject*)list;
 }
 
@@ -3311,9 +2293,8 @@
  * py_pjsua_conf_get_port_info
  */
-static PyObject *py_pjsua_conf_get_port_info
-(PyObject *pSelf, PyObject *pArgs)
+static PyObject *py_pjsua_conf_get_port_info(PyObject *pSelf, PyObject *pArgs)
 {    	
     int id;
-    PyObj_pjsua_conf_port_info * obj;
+    PyObj_pjsua_conf_port_info *ret;
     pjsua_conf_port_info info;
     int status;	
@@ -3322,71 +2303,24 @@
     PJ_UNUSED_ARG(pSelf);
 
-    if (!PyArg_ParseTuple(pArgs, "i", &id))
-    {
-        return NULL;
-    }
-	
+    if (!PyArg_ParseTuple(pArgs, "i", &id)) {
+        return NULL;
+    }
     
     status = pjsua_conf_get_port_info(id, &info);
-    obj = (PyObj_pjsua_conf_port_info *)conf_port_info_new
-	    (&PyTyp_pjsua_conf_port_info,NULL,NULL);
-    obj->bits_per_sample = info.bits_per_sample;
-    obj->channel_count = info.bits_per_sample;
-    obj->clock_rate = info.clock_rate;
-    obj->name = PyString_FromStringAndSize(info.name.ptr, info.name.slen);
-    obj->samples_per_frame = info.samples_per_frame;
-    obj->slot_id = info.slot_id;
-    
-    obj->listeners = (PyListObject *)PyList_New(info.listener_cnt);
+    ret = (PyObj_pjsua_conf_port_info *)
+	  conf_port_info_new(&PyTyp_pjsua_conf_port_info, NULL, NULL);
+    ret->bits_per_sample = info.bits_per_sample;
+    ret->channel_count = info.bits_per_sample;
+    ret->clock_rate = info.clock_rate;
+    ret->name = PyString_FromPJ(&info.name);
+    ret->samples_per_frame = info.samples_per_frame;
+    ret->slot_id = info.slot_id;
+    Py_XDECREF(ret->listeners);
+    ret->listeners = PyList_New(info.listener_cnt);
     for (i = 0; i < info.listener_cnt; i++) {
-	PyObject * item = Py_BuildValue("i",info.listeners[i]);
-	PyList_SetItem((PyObject *)obj->listeners, i, item);
-    }
-    return Py_BuildValue("O", obj);
-}
-
-/*
- * py_pjsua_conf_add_port
- */
-static PyObject *py_pjsua_conf_add_port
-(PyObject *pSelf, PyObject *pArgs)
-{    	
-    int p_id;
-    PyObject * oportObj;
-    PyObj_pjmedia_port * oport;
-    pjmedia_port * port;
-    PyObject * opoolObj;
-    PyObj_pj_pool * opool;
-    pj_pool_t * pool;
-    
-    int status;	
-    
-    PJ_UNUSED_ARG(pSelf);
-
-    if (!PyArg_ParseTuple(pArgs, "OO", &opoolObj, &oportObj))
-    {
-        return NULL;
-    }
-    if (opoolObj != Py_None)
-    {
-        opool = (PyObj_pj_pool *)opoolObj;
-		pool = opool->pool;
-    } else {
-       opool = NULL;
-       pool = NULL;
-    }
-    if (oportObj != Py_None)
-    {
-        oport = (PyObj_pjmedia_port *)oportObj;
-		port = oport->port;
-    } else {
-        oport = NULL;
-        port = NULL;
-    }
-
-    status = pjsua_conf_add_port(pool, port, &p_id);
-    
-    
-    return Py_BuildValue("ii", status, p_id);
+	PyObject *item = Py_BuildValue("i",info.listeners[i]);
+	PyList_SetItem(ret->listeners, i, item);
+    }
+    return (PyObject*)ret;
 }
 
@@ -3394,6 +2328,5 @@
  * py_pjsua_conf_remove_port
  */
-static PyObject *py_pjsua_conf_remove_port
-(PyObject *pSelf, PyObject *pArgs)
+static PyObject *py_pjsua_conf_remove_port(PyObject *pSelf, PyObject *pArgs)
 {    	
     int id;
@@ -3402,6 +2335,5 @@
     PJ_UNUSED_ARG(pSelf);
 
-    if (!PyArg_ParseTuple(pArgs, "i", &id))
-    {
+    if (!PyArg_ParseTuple(pArgs, "i", &id)) {
         return NULL;
     }	
@@ -3409,5 +2341,4 @@
     status = pjsua_conf_remove_port(id);
     
-    
     return Py_BuildValue("i", status);
 }
@@ -3416,6 +2347,5 @@
  * py_pjsua_conf_connect
  */
-static PyObject *py_pjsua_conf_connect
-(PyObject *pSelf, PyObject *pArgs)
+static PyObject *py_pjsua_conf_connect(PyObject *pSelf, PyObject *pArgs)
 {    	
     int source, sink;
@@ -3424,6 +2354,5 @@
     PJ_UNUSED_ARG(pSelf);
 
-    if (!PyArg_ParseTuple(pArgs, "ii", &source, &sink))
-    {
+    if (!PyArg_ParseTuple(pArgs, "ii", &source, &sink)) {
         return NULL;
     }	
@@ -3431,5 +2360,4 @@
     status = pjsua_conf_connect(source, sink);
     
-    
     return Py_BuildValue("i", status);
 }
@@ -3438,6 +2366,5 @@
  * py_pjsua_conf_disconnect
  */
-static PyObject *py_pjsua_conf_disconnect
-(PyObject *pSelf, PyObject *pArgs)
+static PyObject *py_pjsua_conf_disconnect(PyObject *pSelf, PyObject *pArgs)
 {    	
     int source, sink;
@@ -3446,6 +2373,5 @@
     PJ_UNUSED_ARG(pSelf);
 
-    if (!PyArg_ParseTuple(pArgs, "ii", &source, &sink))
-    {
+    if (!PyArg_ParseTuple(pArgs, "ii", &source, &sink)) {
         return NULL;
     }	
